//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "MainFormUnit.h"
#include "TimeChecker.h"
#include <inifiles.hpp>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
   : TForm(Owner){

   TIniFile *ini;
   ini = new TIniFile(ChangeFileExt(Application->ExeName, ".INI"));
   ThinkPath->Text = ini->ReadString("Settings", "ThinkPath", "C:\\Program Files\\Find-A-Drug" );
   Interval->Value = ini->ReadInteger("Settings", "Interval", 30);
   Command->Text = ini->ReadString("Settings", "Command", "rundll32.exe shell32,SHExitWindowsEx 1");
   MonitorSwitch->Checked = ini->ReadBool("Settings", "IsMonitorOn", true);
   delete ini;

   Timer->Interval = 1000 * Interval->Value;

   Savepoint = latestSavepoint(ThinkPath->Text);
   TimerTimer(this);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormClose(TObject *Sender, TCloseAction &Action){
   TIniFile *ini;
   ini = new TIniFile(ChangeFileExt(Application->ExeName, ".INI"));
   ini->WriteString("Settings", "ThinkPath", ThinkPath->Text);
   ini->WriteInteger("Settings", "Interval", Interval->Value);
   ini->WriteString("Settings", "Command", Command->Text);
   ini->WriteBool("Settings", "IsMonitorOn", MonitorSwitch->Checked);

   delete ini;

}
//---------------------------------------------------------------------------

void __fastcall TMainForm::TimerTimer(TObject *Sender){
   Timer->Enabled = false;
   StatusLabel->Caption = "";
   TDateTime tmp = latestSavepoint(ThinkPath->Text);
   if(tmp==TDateTime()){
      StatusLabel->Caption = "Unable to determine when latest savepoint was written.\nPlease make sure THINK folder is specified correctly.";
      MonitorSwitch->Checked = false;
   }else{
      StatusLabel->Caption = AnsiString("The latest savepoint was written at ") + tmp.TimeString();
      if(tmp > Savepoint){
         if(CommandSwitch->Checked){
            StatusLabel->Caption = AnsiString("Executing command:\n") +
                                   Command->Text;
            system(Command->Text.c_str());
         }
      }
   }
   Timer->Enabled = MonitorSwitch->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::UpdateBtnClick(TObject *Sender){
   TimerTimer(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::MonitorSwitchClick(TObject *Sender){
   Timer->Enabled = MonitorSwitch->Checked;
   if(Timer->Enabled)
      TimerTimer(this);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::IntervalChange(TObject *Sender){
   Timer->Interval = 1000 * Interval->Value;
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::ThinkPathChange(TObject *Sender){
   StatusLabel->Caption = "";
   Savepoint = latestSavepoint(ThinkPath->Text);
}
//---------------------------------------------------------------------------

